import { defineStore } from 'pinia'
import { store } from '../index'
import { useCache } from '@/hooks/web/useCache'
import { PageDataTypes, PageDataTypesList } from '@/types/page'

const { wsCache } = useCache('localStorage')

interface AppState {
  pageData: PageDataTypesList
}

export const usePageStore = defineStore('page', {
  state: (): AppState => {
    return {
      pageData: {}
    }
  },
  getters: {
    getPageData(): PageDataTypes {
      return this.pageData
    }
  },
  actions: {
    setPageData(page: string, data: PageDataTypes) {
      this.pageData[page] = data
      wsCache.set('pageData', this.pageData)
    },
    setAllPageData(data: PageDataTypesList) {
      this.pageData = data
    }
  }
})

export const usePageStoreWithOut = () => {
  return usePageStore(store)
}
